-- MySQL dump 10.11
--
-- Host: dns.galway.wan    Database: wifimap-dev
-- ------------------------------------------------------
-- Server version	5.0.32-Debian_7etch1-log

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `links`
--

DROP TABLE IF EXISTS `links`;
CREATE TABLE `links` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `src_node` int(10) unsigned NOT NULL default '0',
  `dest_node` int(10) unsigned NOT NULL default '0',
  `src_ip` varchar(15) NOT NULL default '',
  `linkstatus` enum('planned','client','internode') NOT NULL default 'planned',
  `linktype` enum('a','b','g') NOT NULL default 'b',
  `essid` varchar(128) NOT NULL default '',
  `channel` tinyint(3) unsigned NOT NULL default '0',
  `speed` tinyint(4) NOT NULL default '-1',
  `link_quality` varchar(128) NOT NULL default '',
  `signal_pwr` varchar(128) NOT NULL default '',
  `snr` varchar(128) NOT NULL default '',
  `updated` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `created` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `location`
--

DROP TABLE IF EXISTS `location`;
CREATE TABLE `location` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `country` varchar(2) NOT NULL,
  `region` varchar(2) NOT NULL,
  `city` varchar(127) NOT NULL,
  `lat` float(8,4) NOT NULL,
  `lon` float(8,4) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `node_ips`
--

DROP TABLE IF EXISTS `node_ips`;
CREATE TABLE `node_ips` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `node_id` int(10) unsigned NOT NULL default '0',
  `ip` int(11) NOT NULL,
  `node_type` enum('','staros','mikrotik','icarus','nosnmp') NOT NULL,
  `node_user` varchar(127) NOT NULL,
  `node_pw` varchar(127) NOT NULL default '',
  `node_status` enum('up','down','client','nocheck','unknown') NOT NULL default 'unknown',
  `node_uptime` varchar(128) NOT NULL,
  `date_status` varchar(128) NOT NULL,
  `date_seen` varchar(128) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `nodes`
--

DROP TABLE IF EXISTS `nodes`;
CREATE TABLE `nodes` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `owner_id` int(10) unsigned NOT NULL default '0',
  `longitude` float(7,5) NOT NULL default '0.00000',
  `latitude` float(7,5) NOT NULL default '0.00000',
  `elevation` int(11) NOT NULL default '0',
  `address` varchar(255) NOT NULL default '',
  `comment` varchar(255) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `location` int(10) unsigned NOT NULL default '0',
  `nodetype` enum('client','planned','monitored','unmonitored') NOT NULL default 'planned',
  `status` varchar(128) NOT NULL default '',
  `updated` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `created` timestamp NOT NULL default '0000-00-00 00:00:00',
  `security` enum('public','wan') NOT NULL default 'public',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `settings`
--

DROP TABLE IF EXISTS `settings`;
CREATE TABLE `settings` (
  `version` varchar(8) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
INSERT INTO settings (version) VALUES('20071030');

--
-- Table structure for table `snmp_mac`
--

DROP TABLE IF EXISTS `snmp_mac`;
CREATE TABLE `snmp_mac` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `ip` int(11) NOT NULL,
  `netmask` int(11) NOT NULL,
  `network` bigint(20) unsigned NOT NULL,
  `broadcast` bigint(20) unsigned NOT NULL,
  `mac` varchar(128) NOT NULL default '',
  `interface` varchar(30) NOT NULL,
  `int_status` enum('up','down','manual') NOT NULL,
  `node_id` int(10) unsigned NOT NULL default '0',
  `nid` int(10) unsigned NOT NULL,
  `nip` int(10) unsigned NOT NULL,
  `node_mode` enum('adhoc','master','client') NOT NULL default 'adhoc',
  `node_essid` varchar(128) NOT NULL default '',
  `date_status` varchar(128) NOT NULL,
  `date_seen` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `snmp_node`
--

DROP TABLE IF EXISTS `snmp_node`;
CREATE TABLE `snmp_node` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `ip` int(11) NOT NULL,
  `date_seen` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `users`
--

DROP TABLE IF EXISTS `users`;
CREATE TABLE `users` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `username` varchar(32) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `role` enum('admin','wan','user') NOT NULL default 'user',
  `name` varchar(128) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `status` enum('enabled','disabled','unauthorised') NOT NULL default 'unauthorised',
  `last_login` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `created` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `wan`
--

DROP TABLE IF EXISTS `wan`;
CREATE TABLE `wan` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(128) NOT NULL default '',
  `contact` varchar(128) NOT NULL default '',
  `email` varchar(128) NOT NULL default '',
  `lon` float(7,5) NOT NULL default '0.00000',
  `lat` float(7,5) NOT NULL default '0.00000',
  `geozoom` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
INSERT INTO `wan` VALUES (1, 'TheWan', '', '', -9.25000, 53.30000, 9);

--
-- Table structure for table `waypoints`
--

DROP TABLE IF EXISTS `waypoints`;
CREATE TABLE `waypoints` (
  `name` char(40) default '',
  `type` char(40) default '',
  `id` int(11) NOT NULL auto_increment,
  `lat` double default '0',
  `lon` double default '0',
  `comment` char(160) default '',
  `wep` int(11) NOT NULL default '0',
  `macaddr` char(20) default '0',
  `nettype` int(11) NOT NULL default '0',
  `typenr` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `macindex` (`macaddr`),
  KEY `descrid` (`type`),
  KEY `namekey` (`name`),
  KEY `typenr` (`typenr`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

