<?php

	/*
	 *  $Id: map.php,v 1.306 2007-10-30 19:08:56 marlow Exp $
	 *
	 *  main mapping script
	 *
	 */

	include("include/config.inc");
	include("Mail.php");

	if($_POST["action"] != "")
		$site_options["action"] = $_POST["action"];
	else
		$site_options["action"] = $_GET["action"];

	if($site_options["action"] == "") $site_options["action"] = "view";

	// handle session
	//
	if(($_SESSION["node_id"] == "") AND ($_GET["node_id"] != ""))
		$_SESSION["node_id"] = $_GET["node_id"];

	if($site_options["action"] == "view")
	{
		unset($node_id);
		unset($_SESSION["node_id"]);
		session_unregister("node_id");
	}

	if(($_GET["lon"] != "") AND ($_GET["lon"] != 0))
		$_SESSION["lon"] = $_GET["lon"];
	if(($_GET["lat"] != "") AND ($_GET["lat"] != 0))
		$_SESSION["lat"] = $_GET["lat"];
	if(($_GET["geozoom"] != "") AND ($_GET["geozoom"] != 0))
		$_SESSION["geozoom"] = $_GET["geozoom"];

	// get statistics
	$statistics = array();

	// total node count
	$query  = "SELECT COUNT(id) AS count FROM ".$db_prefix."nodes";
	$storequery .= $query."\n"; // debug

	$q_link = $db->query($query);
	if(DB::isError($q_link)) db_error_handling($q_link, $query);

	$row    = $q_link->fetchRow(DB_FETCHMODE_ASSOC);
	$statistics["nodes_total"] = $row["count"];

	// public node count
	$query  = "SELECT COUNT(id) AS count FROM ".$db_prefix."nodes WHERE security='public'";
	$storequery .= $query."\n"; // debug

	$q_link = $db->query($query);
	if(DB::isError($q_shownode)) db_error_handling($q_link, $query);

	$row    = $q_link->fetchRow(DB_FETCHMODE_ASSOC);
	$statistics["nodes_public"] = $row["count"];

	// functions
	//
	function menu($title, $action = "", $menu = "")
	{
		GLOBAL $site_options, $parent, $statistics;

		$output .= "<TABLE BORDER=\"0\">".$site_options["return"];
		if($title != "")
			$output .= "<TR><TD><B>".$title."</B><BR>&nbsp;</TD></TR>".$site_options["return"];

		// only for authentificated users
		//
		if(($_SESSION["user_id"] != "") AND ($_SESSION["user_id"] != 0))
		{
			if(stristr($action, "node_add"))
				$output .= "<TR><TD><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_add&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Add node</A></TD></TR>".$site_options["return"];
			if(stristr($action, "node_edit"))
				$output .= "<TR><TD><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_edit&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Edit node</A></TD></TR>".$site_options["return"];
			if(stristr($action, "node_find"))
				$output .= "<TR><TD><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_find&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Find node</A></TD></TR>".$site_options["return"];
			if(stristr($action, "loc_add"))
				$output .= "<TR><TD><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=loc_add&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Add location</A></TD></TR>".$site_options["return"];
			//
			// autodiscovery working
			//
			// so this is not really working anymore
			//
			if(stristr($action, "link_add"))
				$output .= "<TR><TD><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=link_add&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Add link</A></TD></TR>".$site_options["return"];
			// end of depreciated functions
			if(stristr($action, "user_edit"))
				$output .= "<TR><TD><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=user_edit&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Edit user data</A></TD></TR>".$site_options["return"];
			if($site_options["action"] != "view" AND $action != "nocancel")
				$output .= "<TR><TD><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Cancel</A></TD></TR>".$site_options["return"];
			if($menu != "")
				$output .= "<TR><TD>".$menu."</TD></TR>".$site_options["return"];
			$output .= "<TR><TD><A HREF=\"".$site_options["pre"]."map.php?action=logout\">Logout</A></TD></TR>".$site_options["return"];
		} else {
			$output .= "<TR><TD>Currently the map has registered ".$statistics["nodes_total"]." nodes, of which ".$statistics["nodes_public"];
			$output .= " are displayed to the public. If the map appears empty, please wait a few seconds. It might take some time to populate the map with nodes and links.</TD></TR>".$site_options["return"];
		
			$output .= "<TR><TD><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=login&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Login</A></TD></TR>".$site_options["return"];
			$output .= "<TR><TD><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=register&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Register</A></TD></TR>".$site_options["return"];
		}
		$output .= "</TABLE>";

		return $output;
	}

	// password generator
	// 
	function givepwd()
	{
		$salt = "abchefghjkmnpqrstuvwxyz23456789";
		srand((double)microtime()*1000000); 
		$i = 0;
		while ($i <= 7) 
		{
			$num = rand() % 33;
			$tmp = substr($salt, $num, 1);
			$pass = $pass . $tmp; 
			$i++;
		}
		return $pass;
	} 

	// convert IP-address to numeric
	//
	function ipnum($ip)
	{
		// ip-address = w.x.y.z

		// w
		$pos   = strpos($ip, ".");
		$ipnum = (16777216*(intval(substr($ip, 0, $pos))));
		// x
		$opos  = $pos;
		$pos   = strpos($ip, ".", $opos+1);
		$ipnum = ($ipnum + (65536*(intval(substr($ip, $opos+1, $pos-$opos-1)))));
		// y
		$opos  = $pos;
		$pos   = strpos($ip, ".", $opos+1);
		$ipnum = ($ipnum + (256*(intval(substr($ip, $opos+1, $pos-$opos-1)))));
		// z
		$opos  = $pos;
		$ipnum = ($ipnum + intval(substr($ip, $opos+1)));

		return $ipnum;
	} 
	
	function update_macdata()
	{
		GLOBAL $db, $db_prefix;
	
		// asssign current nodes in database with snmp_mac database for mapping and geolocation
		//
		$query  = "SELECT N.id,SM.node_id FROM ".$db_prefix."nodes AS N INNER JOIN ".$db_prefix."node_ips AS NI ON N.id=NI.node_id LEFT JOIN ".$db_prefix."snmp_mac AS SM ON SM.ip=NI.ip ";
		$query .= "WHERE SM.node_id IS NOT NULL AND SM.node_id != 0 ";
		// GROUP BY SM.node_id";
		$q_nid  = $db->query($query);
		if(DB::isError($q_nid)) db_error_handling($q_nid, $query);

		while($row = $q_nid->fetchRow(DB_FETCHMODE_ASSOC))
		{
			$query = "UPDATE ".$db_prefix."snmp_mac SET nid='".$row["id"]."' WHERE node_id='".$row["node_id"]."'";
			$q_row = $db->query($query);
			if(DB::isError($q_row)) db_error_handling($q_row, $query);
		}
	}
     
	if(!stristr($site_options["action"],"subm") AND ($site_options["action"] != "logout")) print html_header();

	function netmask_long($netmask)
	{
		// generate long netmask from short netmask
		$long_netmask = "";

		for($x=0; $x<32; $x++)
		if($x<$netmask)
			$long_netmask .= "1";
		else
			$long_netmask .= "0";

		$netmask = long2ip(bindec($long_netmask));

		return $netmask;
	}

	// show google map with nodes and links
	//
	function wan_map($wanid=0, $add_code="", $action="", $uid="")
	{
		GLOBAL $storequery, $db, $site_options, $db_prefix;
	
		// choose GalwayWan Position for now.
		if($wanid == 0)
			$wanid = 1;

		// get map location
		// 
		if(!isset($_SESSION["lon"]) OR ($_SESSION["lon"] == 0))
		{
			$query  = "SELECT lon,lat,geozoom FROM ".$db_prefix."wan WHERE id=".$wanid;
			$storequery .= $query."\n"; // debug

			$q_link = $db->query($query);
			if(DB::isError($q_shownode)) db_error_handling($q_link, $query);

			// draw some of the main links - maybe do this on a separate page
			$row     = $q_link->fetchRow(DB_FETCHMODE_ASSOC);
			$lon     = $row["lon"];
			$lat     = $row["lat"];
			$geozoom = $row["geozoom"];
		} else {
			$lon    = $_SESSION["lon"];
			$lat    = $_SESSION["lat"];
			$geozoom = $_SESSION["geozoom"];
		}

		// initial settings
		$output    .= '<input type="hidden" id="nid" name="nid" value="0">'.$site_options["return"];
		$output    .= '<div id="map" style="position: absolute; top: 10px; left: 10px; width: 700px; height: 600px"></div>'.$site_options["return"];
		$output    .= '  <script type="text/javascript">'.$site_options["return"];
		$output    .= '//<![CDATA['.$site_options["return"].$site_options["return"];
		$output    .= '    var node_id=0;'.$site_options["return"];
		$output    .= '    var lon=0;'.$site_options["return"];
		$output    .= '    var lat=0;'.$site_options["return"];
		$output    .= '    var geozoom=0;'.$site_options["return"];
		$output    .= '    var map = new GMap2(document.getElementById("map"));'.$site_options["return"];
		$output    .= '    map.addControl(new GSmallMapControl());'.$site_options["return"];
		$output    .= '    map.addControl(new GMapTypeControl());'.$site_options["return"];
		$output    .= '    map.setCenter(new GLatLng('.$lat.','.$lon.'), '.$geozoom.');'.$site_options["return"].$site_options["return"];

		// prep output
		//
		$output .= "    var gmarkers = [];".$site_options["return"];
		$output .= "    var id = 0;".$site_options["return"].$site_options["return"];

		// create the marker
		//
		$output .= "    function createMarker(id,point,name,html,status)".$site_options["return"];
		$output .= "    {".$site_options["return"];
		$output .= "      var markerIcon              = new GIcon();".$site_options["return"];
		$output .= "      markerIcon.image            = '".$site_options["pre_img"]."images/mm_20_red.png'".$site_options["return"];
		$output .= "      markerIcon.shadow           = '".$site_options["pre_img"]."images/mm_20_shadow.png'".$site_options["return"];
		$output .= "      markerIcon.iconSize         = new GSize(12, 20);".$site_options["return"];
		$output .= "      markerIcon.shadowSize       = new GSize(22, 20);".$site_options["return"];
		$output .= "      markerIcon.iconAnchor       = new GPoint(6, 20);".$site_options["return"];
		$output .= "      markerIcon.infoWindowAnchor = new GPoint(5, 1);".$site_options["return"];
		$output .= $site_options["return"];
		$output .= "      var marker = new GMarker(point, markerIcon);".$site_options["return"];
		// click action
		$output .= "      GEvent.addListener(marker, \"click\", function() {".$site_options["return"];
		$output .= "        document.getElementById(\"nid\").value = id;".$site_options["return"];
		if($action != "")
			$output .= "        ".$action.$site_options["return"];
		else
			$output .= "        marker.openInfoWindowHtml(html);".$site_options["return"];
		$output .= "      });".$site_options["return"];
		$output .= "      map.addOverlay(marker);".$site_options["return"].$site_options["return"];
		// node status
		$output .= "      if(status == 'up')".$site_options["return"];
		$output .= "        marker.setImage('".$site_options["pre_img"]."images/mm_20_green.png');".$site_options["return"];
		$output .= "      if(status == 'partial')".$site_options["return"];
		$output .= "        marker.setImage('".$site_options["pre_img"]."images/mm_20_yellow.png');".$site_options["return"];
		$output .= "      if(status == 'client')".$site_options["return"];
		$output .= "        marker.setImage('".$site_options["pre_img"]."images/mm_20_blue.png');".$site_options["return"];
		$output .= "      if(status == 'nocheck')".$site_options["return"];
		$output .= "        marker.setImage('".$site_options["pre_img"]."images/mm_20_blue.png');".$site_options["return"];
		$output .= "      if(status == 'unknown')".$site_options["return"];
		$output .= "        marker.setImage('".$site_options["pre_img"]."images/mm_20_blue.png');".$site_options["return"];
		$output .= $site_options["return"];
		$output .= "      gmarkers[id] = marker;".$site_options["return"];
		$output .= "      return marker;".$site_options["return"];
		$output .= "    }".$site_options["return"].$site_options["return"];

		$output .= "    function findMarker(id)".$site_options["return"];
		$output .= "    {".$site_options["return"];
		$output .= "      map.setZoom(13);".$site_options["return"];
		$output .= "      GEvent.trigger(gmarkers[id], \"click\");".$site_options["return"];

		$output .= "    }".$site_options["return"].$site_options["return"];

		// function to find node based on IP address

		$output .= "    function findNode(ip)".$site_options["return"];
		$output .= "    {".$site_options["return"];
		$output .= "      var request = GXmlHttp.create();".$site_options["return"];
		$output .= "      var requesttarget = 'xml.php?action=locate&ip=' + ip;".$site_options["return"];
		$output .= "      request.open(\"GET\", requesttarget, true);".$site_options["return"];
		$output .= "      request.onreadystatechange = function()".$site_options["return"];
		$output .= "      {".$site_options["return"];
		$output .= "        if (request.readyState == 4)".$site_options["return"];
		$output .= "        {".$site_options["return"];
		$output .= "          var xmlDoc = GXml.parse(request.responseText);".$site_options["return"];
		// nodes
		$output .= "          var sourceidxml = xmlDoc.documentElement.getElementsByTagName(\"node\");".$site_options["return"];
		$output .= "          var sourceid = sourceidxml[0].getAttribute(\"id\");".$site_options["return"];
		$output .= "          if(sourceid == 0)".$site_options["return"];
		$output .= "            { alert('IP location unknown !!'); }".$site_options["return"];
		$output .= "          else {".$site_options["return"];
		$output .= "            findMarker(sourceid);".$site_options["return"];
		$output .= "          }".$site_options["return"];
		$output .= "        }".$site_options["return"];
		$output .= "      }".$site_options["return"];
		$output .= "      request.send(null);".$site_options["return"];
		$output .= "    }".$site_options["return"].$site_options["return"];

		// data from XML, source: http://econym.googlepages.com/basic3.htm
		//
		$output .= "    var request = GXmlHttp.create();".$site_options["return"];
		$output .= "    request.open(\"GET\", \"xml.php\", true);".$site_options["return"];
		$output .= "    request.onreadystatechange = function()".$site_options["return"];
		$output .= "    {".$site_options["return"];
		$output .= "      if (request.readyState == 4)".$site_options["return"];
		$output .= "      {".$site_options["return"];
		$output .= "        var xmlDoc = GXml.parse(request.responseText);".$site_options["return"];
		// nodes
		$output .= "        var markers = xmlDoc.documentElement.getElementsByTagName(\"marker\");".$site_options["return"].$site_options["return"];
		$output .= "        for (var i = 0; i < markers.length; i++)".$site_options["return"];
		$output .= "        {".$site_options["return"];
		$output .= "          var lat = parseFloat(markers[i].getAttribute(\"lat\"));".$site_options["return"];
		$output .= "          var lon = parseFloat(markers[i].getAttribute(\"lon\"));".$site_options["return"];
		$output .= "          var point = new GLatLng(lat,lon);".$site_options["return"];
		$output .= "          var id = markers[i].getAttribute(\"id\");".$site_options["return"];
		$output .= "          var status = markers[i].getAttribute(\"status\");".$site_options["return"];
		$output .= "          var html = '';".$site_options["return"];
		$output .= "          var html = '<B>Location:</B> ' + GXml.value(markers[i].getElementsByTagName(\"location\").item(0)) + '<BR>';".$site_options["return"];
		$output .= "          if(GXml.value(markers[i].getElementsByTagName(\"comment\").item(0)) != '') { html += '<B> Comment:</B> ' + GXml.value(markers[i].getElementsByTagName(\"comment\").item(0)) + '<BR>'; };".$site_options["return"];
		$output .= "          if(markers[i].getAttribute(\"time\") != '') { html += '<B> Last check:</B> ' + markers[i].getAttribute(\"time\") + '<BR>'; };".$site_options["return"];
		$output .= "          if(GXml.value(markers[i].getElementsByTagName(\"url\").item(0)) != '') { html += '<B> URL:</B> <A HREF=\"' + GXml.value(markers[i].getElementsByTagName(\"url\").item(0)) + '\">' + GXml.value(markers[i].getElementsByTagName(\"url\").item(0)) + '</A><BR>'; };".$site_options["return"];
		$output .= "          if(GXml.value(markers[i].getElementsByTagName(\"router\").item(0)) != '') { html += '<B> Router:</B><BR>' + GXml.value(markers[i].getElementsByTagName(\"router\").item(0)) + '<BR>'; };".$site_options["return"];
		$output .= "          var label = GXml.value(markers[i].getElementsByTagName(\"location\").item(0));".$site_options["return"];
		$output .= "          var marker = createMarker(id, point, label, html, status);".$site_options["return"];
		$output .= "        }".$site_options["return"].$site_options["return"];
		// links
		$output .= "        var polylines = xmlDoc.documentElement.getElementsByTagName(\"polyline\");".$site_options["return"].$site_options["return"];
		$output .= "        for (var i = 0; i < polylines.length; i++) ".$site_options["return"];
		$output .= "        {".$site_options["return"];
		$output .= "          var latstart = parseFloat(polylines[i].getAttribute(\"latstart\"));".$site_options["return"];
		$output .= "          var lonstart = parseFloat(polylines[i].getAttribute(\"lonstart\"));".$site_options["return"];
		$output .= "          var latend   = parseFloat(polylines[i].getAttribute(\"latend\"));".$site_options["return"];
		$output .= "          var lonend   = parseFloat(polylines[i].getAttribute(\"lonend\"));".$site_options["return"];
		$output .= "          var status   = polylines[i].getAttribute(\"status\");".$site_options["return"];
		$output .= "          var polyline = new GPolyline([new GLatLng(latstart,lonstart),new GLatLng(latend,lonend)],status, 3); ".$site_options["return"];
		$output .= "          map.addOverlay(polyline);".$site_options["return"];
		$output .= "        }".$site_options["return"];
		$output .= "      }".$site_options["return"];
		$output .= "    }".$site_options["return"];
		$output .= $site_options["return"];

		if($add_code != "")
			$output .= $add_code.$site_options["return"];
 
		$output .= "    GEvent.addListener(map, \"moveend\", function() {".$site_options["return"];
		$output .= "      var center = map.getCenter();".$site_options["return"];
		$output .= "      geozoom = map.getZoom();".$site_options["return"];
		$output .= "      var latLngStr = '(' + center.y + ', ' + center.x + ')';".$site_options["return"];
		$output .= "      lon = center.x;".$site_options["return"];
		$output .= "      lat = center.y;".$site_options["return"];
		// $output .= "    document.getElementById(\"message\").innerHTML = latLngStr;".$site_options["return"];
		$output .= "    });".$site_options["return"];
		$output .= "    request.send(null);".$site_options["return"];
		$output .= "//]]>".$site_options["return"];
		$output .= "</script>".$site_options["return"];

		return $output;
	}

	// process map
	//
	switch($site_options["action"])  // no more submaps, here we can add nodes
	{
			case "link_add":

					$action  = "    location.href='".$site_options["pre"]."map.php";
					$action .= "?lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom + '";
					if($_GET["nid1"] != "")
					{
						$action .= "&action=link_save&nid1=".$_GET["nid1"]."&nid2=' + document.getElementById(\"nid\").value + '&lon=".$_SESSION["lon"]."&lat=".$_SESSION["lat"]."&geozoom=".$_SESSION["geozoom"]."';";
						print wan_map(0, "", $action);
					} else {
						$action .= "&action=link_add&nid1=' + document.getElementById(\"nid\").value + '&lon=".$_SESSION["lon"]."&lat=".$_SESSION["lat"]."&geozoom=".$_SESSION["geozoom"]."';";
						print wan_map(0, "", $action, $_SESSION["user_id"]);
					}
					
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                if($_GET["nid1"] == "")
			                	print "    ".menu("Select source node of the link.").$site_options["return"];
			                else 
			                	print "    ".menu("Select destination node of the link.").$site_options["return"];
			                print "</DIV>".$site_options["return"];

			                break;

			case "link_save":
			                // link
			                //
			                print wan_map();

			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                if($_GET["nid1"] == $_GET["nid2"])
			                	print "    ".menu("You can't link a node with itself !!.").$site_options["return"];
					else {
				                print "<FORM NAME=\"node\" METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\">".$site_options["return"];
				                print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"link_subm\">".$site_options["return"];

				                // store data for location
				                //
				                print "<INPUT TYPE=\"hidden\" NAME=\"src_node\" VALUE=\"".$_GET["nid1"]."\">".$site_options["return"];
				                print "<INPUT TYPE=\"hidden\" NAME=\"dest_node\" VALUE=\"".$_GET["nid2"]."\">".$site_options["return"];

				                print "<TABLE BORDER=\"0\">".$site_options["return"];
				                print "<TR><TD><B>Status</B></TD><TD><B>:</B>&nbsp;".$site_options["return"];
				                print "  <SELECT NAME=\"linkstatus\">".$site_options["return"];
				                print "    <OPTION VALUE=\"planned\"";
				                if($node["linkstatus"] == "planned") print " SELECTED";
				                print ">Planned</OPTION>".$site_options["return"];
				                print "    <OPTION VALUE=\"client\"";
				                if($node["linkstatus"] == "client") print " SELECTED";
				                print ">Client</OPTION>".$site_options["return"];
				                print "    <OPTION VALUE=\"internode\"";
				                if($node["linktype"] == "internode") print " SELECTED";
				                print ">Internode</OPTION>".$site_options["return"];
				                print "  </SELECT></TD></TR>".$site_options["return"];
				                print "<TR><TD COLSPAN=\"2\">&nbsp;</TD></TR>".$site_options["return"];
				                print "<TR><TD COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Save data\">&nbsp;<INPUT TYPE=\"RESET\" VALUE=\"Reset fields\">&nbsp;<INPUT TYPE=\"BUTTON\" VALUE=\"Cancel\" onClick=\"location.href='".$site_options["pre"]."map.php'\"></TD></TR>".$site_options["return"];

				                print "</TABLE></FORM>".$site_options["return"];
					}
			                print "</DIV>".$site_options["return"];

			                break;

			case "link_subm":
			                $query = "INSERT INTO ".$db_prefix."links (owner_id, src_node, dest_node, linkstatus, linktype, created) VALUES('".$_SESSION["user_id"]."', '".$_POST["src_node"]."','".$_POST["dest_node"]."','".$_POST["linkstatus"]."','".$_POST["linktype"]."',NOW());";
			                $storequery .= $query."\n"; // debug

			                $u_node = $db->query($query);
			                if(DB::isError($u_node)) db_error_handling($u_node, $query);

			                $db->disconnect();
			                header("Location: ".$site_options["pre"]."map.php");
			                break;

			case "login":
					print wan_map();
		
			                // login, what should i say ?
			                //
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                print "<FORM NAME=\"auth\" METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\">".$site_options["return"];
			                print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"login_subm\">".$site_options["return"];

			                // login form
			                //
			                print "<TABLE BORDER=\"0\">".$site_options["return"];
			                if($_GET["login"] == "failed")
			                	print "<TR><TD COLSPAN=\"2\" ALIGN=\"center\"><B><FONT STYLE=\"color: red;\">Login failed!</B></TD></TR>".$site_options["return"];
			                else
			                	print "<TR><TD COLSPAN=\"2\" ALIGN=\"center\"><B>Please log in.</B></TD></TR>".$site_options["return"];
			                print "<TR><TD><B>Username</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"username\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD><B>Password</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"password\" NAME=\"password\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\">&nbsp;";
			                if($_GET["key"] != "") print "<INPUT TYPE=\"hidden\" NAME=\"key\" VALUE=\"".$_GET["key"]."\">";
			                print "</TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"Login\">&nbsp;<INPUT TYPE=\"button\" VALUE=\"Cancel\" onClick=\"location.href='".$site_options["pre"]."map.php'\"></TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\" ALIGN=\"right\"><A HREF=\"".$site_options["pre"]."map.php?action=orderpw\">Can't remember password ?</A></TD></TR>".$site_options["return"];

			                print "</TABLE></FORM>".$site_options["return"];

			                // end map
			                //
			                print "  </TD></TR>".$site_options["return"];
			                print "</TABLE></DIV>".$site_options["return"];

			                break;

			case "login_subm":
			                if($_POST["key"] != "")
			                	$query = "SELECT id,role FROM ".$db_prefix."users WHERE username='".strtolower($_POST["username"])."' AND password='".md5(strtolower($_POST["password"]))."'";
			                else
			                	$query = "SELECT id,role FROM ".$db_prefix."users WHERE username='".strtolower($_POST["username"])."' AND password='".md5(strtolower($_POST["password"]))."' AND status='enabled'";

					$storequery .= $query."\n"; // debug
			                $u_login = $db->query($query);
			                $query = "";
			                if(DB::isError($u_node)) db_error_handling($u_login, $query);
			                if($u_login->numRows() > 0)
			                {
			                	$row = $u_login->fetchRow(DB_FETCHMODE_ASSOC);
			                	if(($_POST["key"] != "") AND (md5(strtolower($_POST["username"].$_POST["password"])) == $_POST["key"]))
			                		$query = "UPDATE ".$db_prefix."users SET last_login=NOW(),status='enabled' WHERE id='".$row["id"]."'";
			                	if($_POST["key"] == "")
			                		$query = "UPDATE ".$db_prefix."users SET last_login=NOW() WHERE id='".$row["id"]."'";
			                  if($query != "")
			                	{
			                		$_SESSION["user_id"] = $row["id"];
			                		$_SESSION["user_role"] = $row["role"];
			                		$target = $site_options["pre"]."map.php";
			                		$storequery .= $query."\n"; // debug
			                		$u_login = $db->query($query);
			                	} else {
			                		$target = $site_options["pre"]."map.php?action=login&login=failed";
			                		if($_POST["key"] != "") $target .= "&key=".$_POST["key"];
			                	}
			                } else {
			                	$target = $site_options["pre"]."map.php?action=login&login=failed";
			                	if($_POST["key"] != "") $target .= "&key=".$_POST["key"];
			                }
			                $db->disconnect();
			                header("Location: ".$target);
			                break;

			case "logout":
			                session_unset();
			                $db->disconnect();
			                header("Location: ".$site_options["pre"]."map.php");
			                break;

			case "node_add":
			
					$code  = "var markerset = false;".$site_options["return"];
					$code .= "GEvent.addListener(map, 'click', function(overlay, point) {".$site_options["return"];
					$code .= "  if (overlay) {".$site_options["return"];
					$code .= "    map.removeOverlay(overlay);".$site_options["return"];
					$code .= "    document.getElementById(\"longitude\").value = '';".$site_options["return"];
					$code .= "    document.getElementById(\"latitude\").value = '';".$site_options["return"];
					$code .= "    markerset = false;".$site_options["return"];
					$code .= "  } else if (point) {".$site_options["return"];
					$code .= "    if(markerset != true)".$site_options["return"];
					$code .= "    {".$site_options["return"];
					$code .= "      map.addOverlay(new GMarker(point));".$site_options["return"];
					$code .= "      document.getElementById(\"longitude\").value = point.x;".$site_options["return"];
					$code .= "      document.getElementById(\"latitude\").value = point.y;".$site_options["return"];
					$code .= "      markerset = true;".$site_options["return"];
					$code .= "    };".$site_options["return"];
					$code .= "  }".$site_options["return"];
					$code .= "});".$site_options["return"];

					print wan_map(0, $code);

			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                print "<B>Please select the location of the node either by entering gps coordinates in decimal or clicking on the map.</B>".$site_options["return"]."<BR><BR>";
			                print "<FORM METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\" NAME=\"node\">".$site_options["return"];
			                print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"node_subm\">".$site_options["return"];
			                print "<TABLE BORDER=\"0\" WIDTH=\"100%\">".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Location</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"address\" VALUE=\"".$node["address"]."\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Comment</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"comment\" VALUE=\"".$node["comment"]."\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Node type</B></TD><TD NOWRAP><B>:</B>&nbsp;".$site_options["return"];
			                print "  <SELECT NAME=\"nodetype\">".$site_options["return"];
			                print "    <OPTION VALUE=\"client\"";
			                if($node["nodetype"] == "client") print " SELECTED";
			                print ">Client</OPTION>".$site_options["return"];
			                print "    <OPTION VALUE=\"monitored\"";
			                if($node["nodetype"] == "monitored") print " SELECTED";
			                print ">Monitored</OPTION>".$site_options["return"];
			                print "    <OPTION VALUE=\"unmonitored\"";
			                if($node["nodetype"] == "unmonitored") print " SELECTED";
			                print ">Unmonitored</OPTION>".$site_options["return"];
			                print "  </SELECT></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Status</B></TD><TD NOWRAP><B>:</B>&nbsp;".$site_options["return"];
			                print "  <SELECT NAME=\"status\">".$site_options["return"];
			                print "    <OPTION VALUE=\"planned\"";
			                if($node["status"] == "planned") print " SELECTED";
			                print ">Planned</OPTION>".$site_options["return"];
			                print "    <OPTION VALUE=\"active\"";
			                if($node["status"] == "active") print " SELECTED";
			                print ">Active</OPTION>".$site_options["return"];
			                print "  </SELECT></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Security</B></TD><TD NOWRAP><B>:</B>&nbsp;".$site_options["return"];
			                print "  <SELECT NAME=\"security\">".$site_options["return"];
			                print "    <OPTION VALUE=\"public\"";
			                if(($node["security"] == "public") OR ($node["security"] == "")) print " SELECTED";
			                print ">Public</OPTION>".$site_options["return"];
			                print "    <OPTION VALUE=\"wan\"";
			                if($node["security"] == "wan") print " SELECTED";
			                print ">Only seen on the map by Wan Members</OPTION>".$site_options["return"];
			                print "  </SELECT></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>URL</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"url\" VALUE=\"".$node["url"]."\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "  <TR><TD NOWRAP>".$site_options["return"];
			                print "    <B>Lat</B></TD><TD NOWRAP><B>: </B><INPUT TYPE=\"text\" ID=\"latitude\" NAME=\"latitude\" VALUE=\"".$node["latitude"]."\"> Example: 53.17600".$site_options["return"];
			                print "  </TD></TR>".$site_options["return"];
			                print "  <TR><TD NOWRAP>".$site_options["return"];
			                print "    <B>Lon</B></TD><TD NOWRAP><B>: </B><INPUT TYPE=\"text\" ID=\"longitude\" NAME=\"longitude\" VALUE=\"".$node["longitude"]."\"> Example: -8.92900".$site_options["return"];
			                print "  </TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\">&nbsp;</TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"BUTTON\" VALUE=\"Create node\" onClick=\"if(document.getElementById('longitude').value == '') alert('You do not want to place your node south of Nigeria, well ?'); else this.form.submit();\">&nbsp;<INPUT TYPE=\"RESET\" VALUE=\"Reset fields\">&nbsp;<INPUT TYPE=\"BUTTON\" VALUE=\"Cancel\" onClick=\"location.href='".$site_options["pre"]."map.php'\"></TD></TR>".$site_options["return"];
			                print "</TABLE>";
			                print "</FORM></DIV>";
			                break;

			case "node_edit":

					$action = "    location.href='".$site_options["pre"]."map.php?action=node_menu&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom + '&node_id=' + document.getElementById(\"nid\").value;";
					print wan_map(0, "", $action, $_SESSION["user_id"]);

			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                print "    ".menu("Select node to edit.").$site_options["return"];
			                print "  </DIV>".$site_options["return"];
			                break;

			case "node_menu":
			                // map
			                //
			                print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];

			                // editing node ???
			                //
			                if($_GET["node_id"] != "")
			                {
			                	$query  = "SELECT * FROM ".$db_prefix."nodes WHERE id='".$_GET["node_id"]."'";
			                	$storequery .= $query."\n"; // debug
			                	$q_node = $db->query($query);
			                	if(DB::isError($q_node)) db_error_handling($q_node, $query);
			                	$node   = $q_node->fetchRow(DB_FETCHMODE_ASSOC);

						print "<B>Node edit: </B>".$node["address"]."<BR><BR>".$site_options["return"];
						print "<UL>";
						print "<LI><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_info&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom + '&node_id=".$_GET["node_id"]."'\">Edit node information</A><BR><BR></LI>";
					
						// Get a list of AP's at this location
						//
						print "<LI>AP ip addresses:<UL>";
						$query = "SELECT id,ip from ".$db_prefix."node_ips WHERE node_id='".$_GET["node_id"]."' ORDER by ip";
						$storequery .= $query."\n"; // debug
						$q_nodeip = $db->query($query);
						if(DB::isError($q_nodeip)) db_error_handling($q_nodeip, $query);
						while($nodeip = $q_nodeip->fetchRow(DB_FETCHMODE_ASSOC))
						{
							print "<LI><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_ip&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom + '&node_id=".$_GET["node_id"]."&node_ip=".long2ip($nodeip["ip"])."'\">".long2ip($nodeip["ip"])."</A>";
							// manual interfaces ?
							print "<UL><LI><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_manual&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom + '&node_id=".$_GET["node_id"]."&node_ip=".long2ip($nodeip["ip"])."&node_ipid=".$nodeip["id"]."'\">add manual range</A></LI>\n";
							$query       = "SELECT id,ip,netmask FROM ".$db_prefix."snmp_mac WHERE int_status='manual' AND nip='".$nodeip["id"]."'";
							$storequery .= $query."\n"; // debug
							$q_intip     = $db->query($query);
							if(DB::isError($q_intip)) db_error_handling($q_intip, $query);
							while($intip = $q_intip->fetchRow(DB_FETCHMODE_ASSOC))
								print "<LI><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_manual&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom + '&node_id=".$_GET["node_id"]."&node_ip=".long2ip($nodeip["ip"])."&node_ipid=".$nodeip["id"]."&node_rangeid=".$intip["id"]."'\">".long2ip($intip["ip"])."/".strlen(str_replace("0", "", decbin($intip["netmask"])))."</A></LI>\n";
							print "</UL></LI>";
						}

						print "<BR><BR><LI><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_ip&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom + '&node_id=".$_GET["node_id"]."&node_ip=new'\">Create new node-router</A></LI>";
						print "</UL><BR><BR></LI>";
						print "<LI><A HREF=\"".$site_options["pre"]."map.php\">Return to main view</A></LI></UL>";
			                } 

			                print "</DIV>".$site_options["return"];
			                break;

			case "node_info":
			                // map
			                //
			                print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                print "<FORM NAME=\"node\" METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\">".$site_options["return"];
			                print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"node_subm\">".$site_options["return"];

			                // editing node ???
			                //
			                if($_GET["node_id"] != "")
			                {
			                	$query  = "SELECT * FROM ".$db_prefix."nodes WHERE id='".$_GET["node_id"]."'";
			                	$storequery .= $query."\n"; // debug
			                	$q_node = $db->query($query);
			                	if(DB::isError($q_node)) db_error_handling($q_node, $query);
			                	$node   = $q_node->fetchRow(DB_FETCHMODE_ASSOC);

			                	// store data for location
			                	//
			                	print "<INPUT TYPE=\"hidden\" NAME=\"node_id\" VALUE=\"".$_GET["node_id"]."\">".$site_options["return"];
			                } 

			                print "<TABLE BORDER=\"0\">".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Location</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"address\" VALUE=\"".html_entity_decode($node["address"])."\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Comment</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"comment\" VALUE=\"".html_entity_decode($node["comment"])."\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Node type</B></TD><TD NOWRAP><B>:</B>&nbsp;".$site_options["return"];
			                print "  <SELECT NAME=\"nodetype\">".$site_options["return"];
			                print "    <OPTION VALUE=\"client\"";
			                if($node["nodetype"] == "client") print " SELECTED";
			                print ">Client</OPTION>".$site_options["return"];
			                print "    <OPTION VALUE=\"monitored\"";
			                if($node["nodetype"] == "monitored") print " SELECTED";
			                print ">Monitored</OPTION>".$site_options["return"];
			                print "    <OPTION VALUE=\"unmonitored\"";
			                if($node["nodetype"] == "unmonitored") print " SELECTED";
			                print ">Unmonitored</OPTION>".$site_options["return"];
			                print "  </SELECT></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Status</B></TD><TD NOWRAP><B>:</B>&nbsp;".$site_options["return"];
			                print "  <SELECT NAME=\"status\">".$site_options["return"];
			                print "    <OPTION VALUE=\"planned\"";
			                if($node["status"] == "planned") print " SELECTED";
			                print ">Planned</OPTION>".$site_options["return"];
			                print "    <OPTION VALUE=\"active\"";
			                if($node["status"] == "active") print " SELECTED";
			                print ">Active</OPTION>".$site_options["return"];
			                print "  </SELECT></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Security</B></TD><TD NOWRAP><B>:</B>&nbsp;".$site_options["return"];
			                print "  <SELECT NAME=\"security\">".$site_options["return"];
			                print "    <OPTION VALUE=\"public\"";
			                if(($node["security"] == "public") OR ($node["security"] == "")) print " SELECTED";
			                print ">Public</OPTION>".$site_options["return"];
			                print "    <OPTION VALUE=\"wan\"";
			                if($node["security"] == "wan") print " SELECTED";
			                print ">Only seen on the map by Wan Members</OPTION>".$site_options["return"];
			                print "  </SELECT></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>URL</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"url\" VALUE=\"".$node["url"]."\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "  <TR><TD NOWRAP>".$site_options["return"];
			                print "    <B>Lat</B></TD><TD NOWRAP><B>: </B><INPUT TYPE=\"text\" ID=\"latitude\" NAME=\"latitude\" VALUE=\"".$node["latitude"]."\"> Example: 53.17600".$site_options["return"];
			                print "  </TD></TR>".$site_options["return"];
			                print "  <TR><TD NOWRAP>".$site_options["return"];
			                print "    <B>Lon</B></TD><TD NOWRAP><B>: </B><INPUT TYPE=\"text\" ID=\"longitude\" NAME=\"longitude\" VALUE=\"".$node["longitude"]."\"> Example: -8.92900".$site_options["return"];
			                print "  </TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Location (GeoIP)</B></TD><TD NOWRAP><B>:</B>&nbsp;".$site_options["return"];
			                print "  <SELECT NAME=\"location\">".$site_options["return"];
			                print "    <OPTION VALUE=\"0\"";
			                if(($node["location"] == "0") OR ($node["location"] == "")) print " SELECTED";
			                print ">-- none selected --</OPTION>".$site_options["return"];

					$query       = "SELECT * FROM ".$db_prefix."location ORDER BY country,region,city";
					$storequery .= $query."\n"; // debug
					$q_location  = $db->query($query);
					if(DB::isError($q_location)) db_error_handling($q_location, $query);
					while($location = $q_location->fetchRow(DB_FETCHMODE_ASSOC))
					{
				                print "    <OPTION VALUE=\"".$location["id"]."\"";
				                if($node["location"] == $location["id"]) print " SELECTED";
				                print ">".$location["city"].", ".$location["region"].", ".$location["country"]."</OPTION>".$site_options["return"];
					}
			                print "  </SELECT></TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\">&nbsp;</TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Save data\">&nbsp;<INPUT TYPE=\"RESET\" VALUE=\"Reset fields\">&nbsp;<INPUT TYPE=\"BUTTON\" VALUE=\"Cancel\" onClick=\"location.href='".$site_options["pre"]."map.php?action=node_menu&node_id=".$_GET["node_id"]."'\"></TD></TR>".$site_options["return"];
			                print "</TABLE></FORM>".$site_options["return"];
			                print "  </DIV>".$site_options["return"];
			                break;

			case "node_ip":
			                // map
			                //
			                print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];

			                // editing node ???
			                //
			                if($_GET["node_id"] != "")
			                {
				                print "<FORM NAME=\"node\" METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\">".$site_options["return"];
				                print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"ndip_subm\">".$site_options["return"];
			                	print "<INPUT TYPE=\"hidden\" NAME=\"node_id\" VALUE=\"".$_GET["node_id"]."\">".$site_options["return"];

			                	$query  = "SELECT * FROM ".$db_prefix."nodes WHERE id='".$_GET["node_id"]."'";
			                	$storequery .= $query."\n"; // debug
			                	$q_node = $db->query($query);
			                	if(DB::isError($q_node)) db_error_handling($q_node, $query);
			                	$node   = $q_node->fetchRow(DB_FETCHMODE_ASSOC);

						print "<B>Router edit: </B>".$node["address"]."<BR><BR>".$site_options["return"];
						print "AP ".$_GET["node_ip"].":<BR><BR>".$site_options["return"];
						$query = "SELECT * from ".$db_prefix."node_ips WHERE ip='".ip2long($_GET["node_ip"])."'";
						$storequery .= $query."\n"; // debug
						
						$q_nodeip = $db->query($query);
						if(DB::isError($q_nodeip)) db_error_handling($q_nodeip, $query);

						// output ip's, view selected ip for edit
						//
						if($nodeip = $q_nodeip->fetchRow(DB_FETCHMODE_ASSOC))
						{
							// edit router data
							//
							print "<BR>".$site_options["return"];
							print "<INPUT TYPE=\"hidden\" NAME=\"node_ipid\" VALUE=\"".$nodeip["id"]."\">".$site_options["return"];
							print "<TABLE BORDER=\"0\">".$site_options["return"];
							print "<TR><TD NOWRAP>IP address:</TD><TD NOWRAP><INPUT TYPE=\"text\" NAME=\"node_ip\" VALUE=\"".long2ip($nodeip["ip"])."\"> - empty to delete router.</TD></TR>".$site_options["return"];
							print "<TR><TD NOWRAP>System Type:</TD><TD><SELECT NAME=\"node_type\">".$site_options["return"];
							print "  <OPTION VALUE=\"\"";
							if($nodeip["node_type"] == "") print " SELECTED";
							print "></OPTION>".$site_options["return"];
							print "  <OPTION VALUE=\"staros\"";
							if($nodeip["node_type"] == "staros") print " SELECTED";
							print ">StarOS</OPTION>".$site_options["return"];
							print "  <OPTION VALUE=\"mikrotik\"";
							if($nodeip["node_type"] == "mikrotik") print " SELECTED";
							print ">Mikrotik RouterOS</OPTION>".$site_options["return"];
							print "  <OPTION VALUE=\"icarus\"";
							if($nodeip["node_type"] == "icarus") print " SELECTED";
							print ">IcarusOS</OPTION>".$site_options["return"];
							print "  <OPTION VALUE=\"nosnmp\"";
							if($nodeip["node_type"] == "nosnmp") print " SELECTED";
							print ">SNMP no supported</OPTION>".$site_options["return"];
							print "</SELECT></TD></TR>".$site_options["return"];
							print "<TR><TD NOWRAP>User:</TD><TD NOWRAP><INPUT TYPE=\"text\" NAME=\"node_user\"";
							if($nodeip["node_user"] != "") print " VALUE=\"".$nodeip["node_user"]."\"";
							print "></TD></TR>".$site_options["return"];
							print "<TR><TD NOWRAP>Password:</TD><TD NOWRAP><INPUT TYPE=\"password\" NAME=\"node_pw\"";
							if($nodeip["node_pw"] != "") 
							{
								print " VALUE=\"";
								for ($x=0; $x<strlen($nodeip["node_pw"]); $x++) print "*";
								print "\"";
							}
							print "></TD></TR>".$site_options["return"];
							print "<TR><TD NOWRAP COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Save data\">&nbsp;<INPUT TYPE=\"RESET\" VALUE=\"Reset fields\"></TD></TR>".$site_options["return"];
							print "</TABLE>".$site_options["return"];
						
							// get snmp node_id from database
							//
							$query = "SELECT node_id FROM ".$db_prefix."snmp_mac WHERE ip='".ip2long($_GET["node_ip"])."'";
							$storequery .= $query."\n"; // debug
							$q_nodesnmp = $db->query($query);
							if(DB::isError($q_nodesnmp)) db_error_handling($q_nodesnmp, $query);
							$node_snmp_id = $q_nodesnmp->fetchRow(DB_FETCHMODE_ASSOC);
						
							// get associated ips/mac/interfaces
							//
							if($node_snmp_id["node_id"] != 0)
							{
								$query = "SELECT * FROM ".$db_prefix."snmp_mac WHERE node_id='".$node_snmp_id["node_id"]."'";
								$storequery .= $query."\n"; // debug
								$q_node_int = $db->query($query); 
								if(DB::isError($q_node_int)) db_error_handling($q_node_int, $query);
						
								print "<UL>";
								while($node_snmp_int = $q_node_int->fetchRow(DB_FETCHMODE_ASSOC))
								{
									print "<LI>".long2ip($node_snmp_int["ip"])."</LI>";
								}
								print "</UL>";
							}
						}

						if($_GET["node_ip"] == "new")
						{
							// enter new router data
							//
							print "<INPUT TYPE=\"hidden\" NAME=\"node_ipid\" VALUE=\"".$_GET["node_ip"]."\"><BR>".$site_options["return"]; 
							print "<TABLE BORDER=\"0\">".$site_options["return"];
							print "<TR><TD NOWRAP>IP Address:</TD><TD><INPUT TYPE=\"text\" NAME=\"node_ip\"></TD></TR>".$site_options["return"];
							print "<TR><TD NOWRAP>System Type:</TD><TD><SELECT NAME=\"node_type\">".$site_options["return"];
							print "  <OPTION VALUE=\"\"";
							print "></OPTION>".$site_options["return"];
							print "  <OPTION VALUE=\"staros\"";
							print ">StarOS</OPTION>".$site_options["return"];
							print "  <OPTION VALUE=\"mikrotik\"";
							print ">Mikrotik RouterOS</OPTION>".$site_options["return"];
							print "  <OPTION VALUE=\"icarus\"";
							print ">IcarusOS</OPTION>".$site_options["return"];
							print "  <OPTION VALUE=\"nosnmp\"";
							print ">SNMP not supported</OPTION>".$site_options["return"];
							print "</SELECT></TD></TR>".$site_options["return"];
							print "<TR><TD NOWRAP>User:</TD><TD NOWRAP><INPUT TYPE=\"text\" NAME=\"node_user\"></TD></TR>".$site_options["return"];
							print "<TR><TD NOWRAP>Password:</TD><TD NOWRAP><INPUT TYPE=\"password\" NAME=\"node_pw\"></TD></TR>".$site_options["return"];
							print "<TR><TD NOWRAP COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Save data\">&nbsp;<INPUT TYPE=\"RESET\" VALUE=\"Reset fields\"></TD></TR>".$site_options["return"];
							print "</TABLE>".$site_options["return"];
						}

						print "<UL><LI><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_menu&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom + '&node_id=".$_GET["node_id"]."'\">Return to node edit</A></LI></UL>";
						print "</FORM>";
			                } 

			                print "  </DIV>".$site_options["return"];
			                break;

			case "node_manual":
					// map
					//
					print wan_map();
					print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];

					// editing node ???
					//
					if($_GET["node_id"] != "")
					{
						print "<FORM NAME=\"node\" METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\">".$site_options["return"];
						// edit current range
						//
						if($_GET["node_rangeid"] != "")
						{
							$query = "SELECT ip,netmask FROM ".$db_prefix."snmp_mac WHERE id='".$_GET["node_rangeid"]."'";
							$storequery .= $query."\n"; // debug
							$q_node = $db->query($query);
							$intip  = $q_node->fetchRow(DB_FETCHMODE_ASSOC);
							
							$ipmask = long2ip($intip["ip"])."/".strlen(str_replace("0", "", decbin($intip["netmask"])));
						}

						print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"range_subm\">".$site_options["return"];
						print "<INPUT TYPE=\"hidden\" NAME=\"node_id\" VALUE=\"".$_GET["node_id"]."\">".$site_options["return"];
						print "<INPUT TYPE=\"hidden\" NAME=\"node_ipid\" VALUE=\"".$_GET["node_ipid"]."\">".$site_options["return"];
						print "<INPUT TYPE=\"hidden\" NAME=\"range_id\" VALUE=\"".$_GET["node_rangeid"]."\">".$site_options["return"];

						$query  = "SELECT * FROM ".$db_prefix."nodes WHERE id='".$_GET["node_id"]."'";
						$storequery .= $query."\n"; // debug
						$q_node = $db->query($query);
						if(DB::isError($q_node)) db_error_handling($q_node, $query);
						$node   = $q_node->fetchRow(DB_FETCHMODE_ASSOC);

						print "<B>Router edit: </B>".$node["address"]."<BR><BR>".$site_options["return"];
						print "AP ".$_GET["node_ip"]."<BR><BR>".$site_options["return"];
						
						print "<TABLE BORDER=\"0\">\n";
						print "<TR><TD NOWRAP>IP/netmask:</TD><TD NOWRAP><INPUT TYPE=\"text\" NAME=\"node_range\"";
						if($ipmask != "") print " VALUE=\"".$ipmask."\"";
						print ">";
						if($ipmask != "") print " - blank to delete range";
						print "</TD></TR>".$site_options["return"];
						print "<TR><TD NOWRAP COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"SUBMIT\" VALUE=\"Save data\">&nbsp;<INPUT TYPE=\"RESET\" VALUE=\"Reset fields\"></TD></TR>".$site_options["return"];
						print "</TABLE>".$site_options["return"];

						print "<UL><LI><A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?action=node_menu&lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom + '&node_id=".$_GET["node_id"]."'\">Return to node edit</A></LI></UL>";
						print "</FORM>";
			                } 

			                print "  </DIV>".$site_options["return"];
			                break;

			case "loc_add":
					// Geographical location (nearest city) for GeoIP purposes
					//
					
					$code  = "var markerset = false;".$site_options["return"];
					$code .= "GEvent.addListener(map, 'click', function(overlay, point) {".$site_options["return"];
					$code .= "  if (overlay) {".$site_options["return"];
					$code .= "    map.removeOverlay(overlay);".$site_options["return"];
					$code .= "    document.getElementById(\"longitude\").value = '';".$site_options["return"];
					$code .= "    document.getElementById(\"latitude\").value = '';".$site_options["return"];
					$code .= "    markerset = false;".$site_options["return"];
					$code .= "  } else if (point) {".$site_options["return"];
					$code .= "    if(markerset != true)".$site_options["return"];
					$code .= "    {".$site_options["return"];
					$code .= "      map.addOverlay(new GMarker(point));".$site_options["return"];
					$code .= "      document.getElementById(\"longitude\").value = point.x;".$site_options["return"];
					$code .= "      document.getElementById(\"latitude\").value = point.y;".$site_options["return"];
					$code .= "      markerset = true;".$site_options["return"];
					$code .= "    };".$site_options["return"];
					$code .= "  }".$site_options["return"];
					$code .= "});".$site_options["return"];

					print wan_map(0, $code);

			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                print "<B>Please select the location either by entering gps coordinates in decimal or clicking on the map.</B>".$site_options["return"]."<BR><BR>";
			                print "<FORM METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\" NAME=\"node\">".$site_options["return"];
			                print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"loc_subm\">".$site_options["return"];
			                print "<TABLE BORDER=\"0\" WIDTH=\"100%\">".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Country</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"country\" VALUE=\"".$location["country"]."\" SIZE=\"2\"> - 2 digit ISO country code</TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Region</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"region\" VALUE=\"".$location["region"]."\" SIZE=\"2\"> - 2 digit FIPS region code</TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>City/Village</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"city\" VALUE=\"".$location["city"]."\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "  <TR><TD NOWRAP>".$site_options["return"];
			                print "    <B>Lat</B></TD><TD NOWRAP><B>: </B><INPUT TYPE=\"text\" ID=\"latitude\" NAME=\"latitude\" VALUE=\"".$location["latitude"]."\"> Example: 53.17600".$site_options["return"];
			                print "  </TD></TR>".$site_options["return"];
			                print "  <TR><TD NOWRAP>".$site_options["return"];
			                print "    <B>Lon</B></TD><TD NOWRAP><B>: </B><INPUT TYPE=\"text\" ID=\"longitude\" NAME=\"longitude\" VALUE=\"".$location["longitude"]."\"> Example: -8.92900".$site_options["return"];
			                print "  </TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\">&nbsp;</TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"BUTTON\" VALUE=\"Create location\" onClick=\"if(document.getElementById('longitude').value == '') alert('You do not want to place your node south of Nigeria, well ?'); else this.form.submit();\">&nbsp;<INPUT TYPE=\"RESET\" VALUE=\"Reset fields\">&nbsp;<INPUT TYPE=\"BUTTON\" VALUE=\"Cancel\" onClick=\"location.href='".$site_options["pre"]."map.php'\"></TD></TR>".$site_options["return"];
			                print "</TABLE>";
			                print "</FORM></DIV>";
			                break;

			case "range_subm":
					
					if($_POST["node_range"] != "")
					{
						$ip      = ip2long(substr($_POST["node_range"], 0, strpos($_POST["node_range"], "/")));
						$netmask = substr($_POST["node_range"], strpos($_POST["node_range"],"/")+1);
						if(strlen($netmask) < 3) 
							$netmask = ip2long(netmask_long($netmask));
						else
							$netmask = ip2long($netmask);
						
						$network   = ($ip & $netmask);
						$broadcast = $network | (~$netmask);
					
						if($_POST["range_id"] == "")
						{
							// new ip/netmask added
							$query  = "INSERT INTO ".$db_prefix."snmp_mac (ip, netmask, network, broadcast, mac, int_status, nid, nip, date_status, date_seen) ";
							$query .= "VALUES('".$ip."','".$netmask."','".ipnum(long2ip($network))."','".ipnum(long2ip($broadcast))."','00:00:00:00:00:00','manual','".$_POST["node_id"]."','";
							$query .= $_POST["node_ipid"]."','".time()."','".time()."')";
						} else {
							// update range already on router
							$query  = "UPDATE ".$db_prefix."snmp_mac SET ip='".$ip."',netmask='".$netmask."',network='".ipnum(long2ip($network))."',broadcast='".ipnum(long2ip($broadcast))."',";
							$query .= "date_status='".time()."',date_seen='".time()."' WHERE id='".$_POST["range_id"]."'";
						}
						$storequery .= $query."\n"; // debug
						$q_node = $db->query($query);
						if(DB::isError($q_node)) db_error_handling($q_node, $query);
					} else {
						// remove range from router
						//
						$query = "DELETE FROM ".$db_prefix."snmp_mac WHERE id='".$_POST["range_id"]."'";
						$storequery .= $query."\n"; // debug
						$q_node = $db->query($query);
						if(DB::isError($q_node)) db_error_handling($q_node, $query);
					}
					
					$location = $site_options["pre"]."map.php";
					if($_POST["node_id"] != "") $location .= "?action=node_menu&node_id=".$_POST["node_id"];
		                	header("Location: ".$location);

					break;

			case "loc_subm":
					// store GeoLocations in database
					//

			                if($_POST["loc_id"] == "")
			                {
			                	$query  = "INSERT INTO ".$db_prefix."location (country, region, city, lat, lon) VALUES('".$_POST["country"]."','".$_POST["region"]."','".$_POST["city"]."','";
			                	$query .= $_POST["latitude"]."','".$_POST["longitude"]."')";
			                } else {
			                	// edit not possible yet
			                }
			                $storequery .= $query."\n"; // debug
			                $u_loc = $db->query($query);
			                if(DB::isError($u_loc)) db_error_handling($u_loc, $query);
					$db->disconnect();			                
			                
					$location = $site_options["pre"]."map.php";
		                	header("Location: ".$location);

			                break;

			case "node_subm":
			                $mac_delimiters = array(":", "-", ".", " ");
			                if($_POST["node_id"] == "")
			                {
			                	if((substr($_POST["url"], 0, 4) != "http") AND ($_POST["url"] != ""))
			                		$url = "http://".$_POST["url"];
						else
							$url = $_POST["url"];
						$query  = "INSERT INTO ".$db_prefix."nodes (owner_id, longitude, latitude, address, comment, nodetype, status, url, location, created, security) ";
			                	$query .= "VALUES('".$_SESSION["user_id"]."','".$_POST["longitude"]."','".$_POST["latitude"]."','".$_POST["address"]."','".$_POST["comment"]."','";
			                	$query .= $_POST["nodetype"]."','".$_POST["status"]."','". $url ."','".$_POST["location"]."',NOW(), '".$_POST["security"]."')";
			                } else {
			                	if((substr($_POST["url"], 0, 4) != "http") AND ($_POST["url"] != ""))
			                		$url = "http://".$_POST["url"];
						else
							$url = $_POST["url"];
			                	$query  = "UPDATE ".$db_prefix."nodes SET address='".htmlentities($_POST["address"])."',comment='".htmlentities($_POST["comment"])."',";
			                	$query .= "nodetype='".$_POST["nodetype"]."',status='".$_POST["status"]."',security='".$_POST["security"]."',";
			                	$query .= "url='". $url ."',location='".$_POST["location"]."',updated=NOW() WHERE id='".$_POST["node_id"]."'";
			                }
			                $storequery .= $query."\n"; // debug
			                $u_node = $db->query($query);
			                if(DB::isError($u_node)) db_error_handling($u_node, $query);

					$db->disconnect();			                
			                
			                // query debug
					if($_SESSION["mapdebug"] == "yes")
					{
						print $query;
						die;
					} else {
						$location = $site_options["pre"]."map.php";
						if($_POST["node_id"] != "") $location .= "?action=node_menu&node_id=".$_POST["node_id"];
			                	header("Location: ".$location);
					}

			                break;

			case "ndip_subm":
					// update router data
					//
					if(isset($_POST["node_ipid"]) AND ($_POST["node_ipid"] != ""))
					{
						// * is not allowed and the default to not show the password
						$pw = str_replace('*','',$_POST["node_pw"]);
										
						// router not specify, whipe password
						if($_POST["node_type"] == "") $_POST["node_pw"] = "";
						
						// create new node ?
						if($_POST["node_ipid"] == "new")
							$query  = "INSERT INTO ".$db_prefix."node_ips (node_id, ip, node_type, node_user, node_pw) VALUES('".$_POST["node_id"]."','".ip2long($_POST["node_ip"])."','".$_POST["node_type"]."','".$_POST["node_user"]."','".$pw."')";
						else
						{
							// ip still set ? if not, delete ap
							if($_POST["node_ip"] == "")
							{
								// remove router and manual ranges
								//
								$query       = "DELETE FROM ".$db_prefix."node_ips WHERE id='".$_POST["node_ipid"]."'";
								$storequery .= $query."\n"; // debug
								$q_nodeip    = $db->query($query);
								if(DB::isError($q_node)) db_error_handling($q_nodeip, $query);
								// find node_id for snmp_node
								//
								$query       = "SELECT node_id FROM ".$db_prefix."snmp_mac WHERE nid='".$_POST["node_ipid"]."' AND node_id != '0'";
								$storequery .= $query."\n"; // debug
								$q_nodeip    = $db->query($query);
								if(DB::isError($q_node)) db_error_handling($q_nodeip, $query);
								if($q_nodeip->numRows() > 0)
								{
									$node        = $q_nodeip->fetchRow(DB_FETCHMODE_ASSOC);
									// delete record from snmp_node
									//
									$query       = "DELETE FROM ".$db_prefix."snmp_node WHERE id='".$node["node_id"]."'";
									$storequery .= $query."\n"; // debug
									$q_nodeip    = $db->query($query);
									if(DB::isError($q_node)) db_error_handling($q_nodeip, $query);
								}
								// delete records from snmp_mac
								//
								$query = "DELETE FROM ".$db_prefix."snmp_mac WHERE nip='".$_POST["node_ipid"]."'";
							} else {
								// edit of router data, just update
								$query  = "UPDATE ".$db_prefix."node_ips SET ip='".ip2long($_POST["node_ip"])."',node_type='".$_POST["node_type"]."',node_user='".$_POST["node_user"]."'";
								if(($pw != "") OR ($_POST["node_pw"] == "")) $query .= ",node_pw='".$pw."'";
								$query .= " WHERE id='".$_POST["node_ipid"]."'";
							}
						}
						$storequery .= $query."\n"; // debug
						$q_nodeip = $db->query($query);
						if(DB::isError($q_node)) db_error_handling($q_nodeip, $query);
					}
					
					update_macdata();
					
					header("Location: ".$site_options["pre"]."map.php?action=node_menu&node_id=".$_POST["node_id"]);
					break;

			case "user_edit":
			                // print map
			                //
			                print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];

			                // editing user
			                //
			                if($_SESSION["user_id"] != "")
			         		if(!isset($_POST["action"]) OR $_POST["password"] != $_POST["repeat_pw"] OR $_POST["email"] == "")
				                {
				                	// user wants to edit details or went wrong somewhere
				                	//
					                print "<FORM NAME=\"user\" METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\">".$site_options["return"];
					                print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"user_edit\">".$site_options["return"];

				                	if(!isset($_POST["action"]))
				                	{
					                	$query  = "SELECT * FROM ".$db_prefix."users WHERE id='".$_SESSION["user_id"]."'";
				        	        	$storequery .= $query."\n"; // debug
				                		$q_user = $db->query($query);
				                		if(DB::isError($q_user)) db_error_handling($q_user, $query);
					                	$user   = $q_user->fetchRow(DB_FETCHMODE_ASSOC);
							} else {
								$user = array();
								$user["name"]     = htmlentities($_POST["name"]);
								$user["email"]    = $_POST["email"];
							}
			                	
							// error messages
							//
							if($_POST["password"] != $_POST["repeat_pw"])
								print "<TR><TD COLSPAN=\"2\" ALIGN=\"center\"><B><FONT STYLE=\"color: red;\">Passwords did not match !</FONT></B></TD></TR>".$site_options["return"];
							else
								if($_POST["email"] == "" AND isset($_POST["action"])) print "<TR><TD COLSPAN=\"2\" ALIGN=\"center\"><B><FONT STYLE=\"color: red;\">You forgot the eMail-address !</FONT></B></TD></TR>".$site_options["return"];

					                // user data form
					                //
					                print "<TABLE BORDER=\"0\">".$site_options["return"];
					                print "<TR><TD NOWRAP><B>Name</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"name\" SIZE=\"25\" VALUE=\"".html_entity_decode($user["name"])."\"></TD></TR>".$site_options["return"];
			        		        print "<TR><TD NOWRAP><B>Username</B></TD><TD NOWRAP><B>:</B>".$user["username"]."</TD></TR>".$site_options["return"];
			        		        print "<TR><TD NOWRAP><B>Password</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"password\" NAME=\"password\" SIZE=\"25\" VALUE=\"XXXX\"></TD></TR>".$site_options["return"];
					                print "<TR><TD NOWRAP><B>Repeat PW</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"password\" NAME=\"repeat_pw\" SIZE=\"25\" VALUE=\"XXXX\"></TD></TR>".$site_options["return"];
					                print "<TR><TD NOWRAP><B>eMail</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"email\" SIZE=\"25\" VALUE=\"".$user["email"]."\"></TD></TR>".$site_options["return"];
					                print "<TR><TD NOWRAP COLSPAN=\"2\">&nbsp;</TD></TR>".$site_options["return"];
					                print "<TR><TD NOWRAP COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"Update\">&nbsp;<INPUT TYPE=\"button\" VALUE=\"Cancel\" onClick=\"location.href='".$site_options["pre"]."map.php'\"></TD></TR>".$site_options["return"];

			        		        print "</TABLE></FORM>".$site_options["return"];

						} else {
						
							// submit changes to database
							$query = "UPDATE ".$db_prefix."users SET name='".htmlentities($_POST["name"])."',email='".$_POST["email"]."'";
							if($_POST["password"] != "XXXX" AND $_POST["password"] != "" AND $_POST["password"] == $_POST["repeat_pw"])
								$query .= ",password='".md5(strtolower($_POST["password"]))."'";
							$query .= " WHERE id='".$_SESSION["user_id"]."'";
					                $storequery .= $query."\n"; // debug
					                $u_user = $db->query($query);
			        		        if(DB::isError($u_user)) db_error_handling($u_user, $query);

			                  		print menu("Your user data have been updated.", "nocancel", "<A HREF=\"javascript:location.href='".$site_options["pre"]."map.php?lon=' + lon + '&lat=' + lat + '&geozoom=' + geozoom\">Main menu</A>");
						}

			                print "  </DIV>".$site_options["return"];
			                break;

			case "orderpw":
			                // login, what should i say ?
			                //
			                print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                print "<FORM NAME=\"orderpw\" METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\">".$site_options["return"];
			                print "<INPUT TYPE=\"hidden\" NAME=\"action\" VALUE=\"opw_send\">";

			                // form for ordering a new password
			                //
			                print "<TABLE BORDER=\"0\">".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\"><B>Please enter your eMail address.</B></TD></TR>".$site_options["return"];
			                print "<TR><TD>eMail</TD><TD NOWRAP>:&nbsp;<INPUT TYPE=\"text\" NAME=\"email\" SIZE=\"30\"></TD></TR>".$site_options["return"];
			                print "<TR><TD COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"Order\">&nbsp;<INPUT TYPE=\"button\" VALUE=\"Cancel\" onClick=\"location.href='".$site_options["pre"]."map.php'\"></TD></TR>".$site_options["return"];
			                print "</TABLE></FORM>".$site_options["return"];

			                // end map
			                //
			                print "  </TD></TR>".$site_options["return"];
			                print "</TABLE></DIV>";

			                break;

			case "opw_send":
			                print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];

			                $query = "SELECT id FROM ".$db_prefix."users WHERE email='".strtolower($_POST["email"])."'";

			                $storequery .= $query."\n"; // debug
			                $u_login = $db->query($query);
			                if(DB::isError($u_node)) db_error_handling($u_login, $query);
			                if($u_login->numRows() > 0)
			                {
			                	$row = $u_login->fetchRow(DB_FETCHMODE_ASSOC);
			                	$password = givepwd();
			                	$query = "UPDATE ".$db_prefix."users SET password='".md5($password)."' WHERE id='".$row["id"]."'";
			                	$storequery .= $query."\n"; // debug
			                	$u_login = $db->query($query);

			                	// Preparing for sending email with new password
			                	//
			                	$body  = str_replace('%s', $password, 'Hi, your new password for the wifimap is %s.');
			                	$body .= "\n\n";

			                	$headers["Subject"] = "wifimap Password Recovery";
			                	$headers["From"]    = $site_options["serveradmin"];
			                	$headers["To"]      = $_POST["email"];

			                	$params["host"]     = $site_options["smtp_host"];
			                	$mailer  = &Mail::factory('smtp', $params);
			                	$status  = $mailer->send($_POST["email"], $headers, $body);
			                	if (PEAR::isError($status)) 
				                  	print menu("Mail could not be send. Contact site administrator !");
		        	          	else
			                		print menu("An eMail with a new password has been send.");
			                } else
			                	print menu("Could not find account !");
			                print "  </DIV>".$site_options["return"];

			                break;

			case "register":
			                // not a registered user yet ?
			                //
			                print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                print "<FORM NAME=\"register\" METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\">".$site_options["return"];
			                print "<INPUT TYPE=\"hidden\" NAME=\"action\" value=\"reg_send\">".$site_options["return"];

			                // login form
			                //
			                print "<TABLE BORDER=\"0\">".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Name</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"name\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Username</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"username\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Password</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"password\" NAME=\"password\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>Repeat PW</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"password\" NAME=\"repeat_pw\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP><B>eMail</B></TD><TD NOWRAP><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"email\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP COLSPAN=\"2\">&nbsp;</TD></TR>".$site_options["return"];
			                print "<TR><TD NOWRAP COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"Register\">&nbsp;<INPUT TYPE=\"button\" VALUE=\"Cancel\" onClick=\"location.href='".$site_options["pre"]."map.php'\"></TD></TR>".$site_options["return"];

			                print "</TABLE></FORM>".$site_options["return"];

			                // end map
			                //
			                print "  </TD></TR>".$site_options["return"];
			                print "</TABLE></DIV>";

			                break;

			case "reg_send":
			                // registering user
			                //
			                print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
			                print "<FORM NAME=\"register\" METHOD=\"post\" ACTION=\"".$site_options["pre"]."map.php\">".$site_options["return"];
					print "<INPUT TYPE=\"hidden\" NAME=\"action\" value=\"reg_send\">".$site_options["return"];

			                // login form
			                //
			                print "<TABLE BORDER=\"0\">".$site_options["return"];

			                // check if username exists.
			                //
			                $query = "SELECT id FROM ".$db_prefix."users WHERE username='".strtolower($_POST["username"])."'";

			                $storequery .= $query."\n"; // debug
			                $u_login = $db->query($query);
			                if(DB::isError($u_node)) db_error_handling($u_login, $query);
			                if(($u_login->numRows() == 0) AND ($_POST["password"] == $_POST["repeat_pw"]) AND ($_POST["username"] != "") AND ($_POST["email"] != ""))
			                {
			                	$query = "INSERT INTO ".$db_prefix."users (username, password, name, email, created) VALUES('".strtolower($_POST["username"])."', '".md5(strtolower($_POST["password"]))."', '".htmlentities($_POST["name"])."', '".strtolower($_POST["email"])."', NOW())";
			                	$storequery .= $query."\n"; // debug
			                	$u_login = $db->query($query);
			                	if(DB::isError($u_login)) db_error_handling($u_login, $query);

			                	// Preparing for sending activation email
			                	//
			                	$body  = str_replace('%s', "http://".$_SERVER["HTTP_HOST"].$site_options["pre"]."map.php?action=login&key=".md5(strtolower($_POST["username"].$_POST["password"])), 'Hi, please go to %s and login with the username and password chosen, to activate your account.');
			                	$body .= "\n\n";

			                	$headers["Subject"] = "wifimap Registration";
			                	$headers["From"]    = $site_options["serveradmin"];
			                	$headers["To"]      = $_POST["email"];

			                	$params["host"]     = $site_options["smtp_host"];
			                	$mailer  = &Mail::factory('smtp', $params);
			                	$status  = $mailer->send($_POST["email"], $headers, $body);
			                	if (PEAR::isError($status)) 
			                  		print menu("Mail could not be send. Contact site administrator.");
						else
							print menu("An activation eMail has been send.");
			                } else {
			                	if($_POST["password"] != $_POST["repeat_pw"])
			                		print "<TR><TD COLSPAN=\"2\" ALIGN=\"center\"><B><FONT STYLE=\"color: red;\">Username is taken !</FONT></B></TD></TR>".$site_options["return"];
			                	else
			                		if($_POST["email"] == "")
			                			print "<TR><TD COLSPAN=\"2\" ALIGN=\"center\"><B><FONT STYLE=\"color: red;\">You forgot the eMail-address !</FONT></B></TD></TR>".$site_options["return"];
			                		else
			                			print "<TR><TD COLSPAN=\"2\" ALIGN=\"center\"><B><FONT STYLE=\"color: red;\">Username is taken !</FONT></B></TD></TR>".$site_options["return"];
			                	print "<TR><TD><B>Name</B></TD><TD><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"name\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                	print "<TR><TD><B>Username</B></TD><TD><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"username\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                	print "<TR><TD><B>Password</B></TD><TD><B>:</B>&nbsp;<INPUT TYPE=\"password\" NAME=\"password\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                	print "<TR><TD><B>Repeat PW</B></TD><TD><B>:</B>&nbsp;<INPUT TYPE=\"password\" NAME=\"repeat_pw\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                	print "<TR><TD><B>eMail</B></TD><TD><B>:</B>&nbsp;<INPUT TYPE=\"text\" NAME=\"email\" SIZE=\"25\"></TD></TR>".$site_options["return"];
			                	print "<TR><TD COLSPAN=\"2\">&nbsp;</TD></TR>".$site_options["return"];
			                	print "<TR><TD COLSPAN=\"2\" ALIGN=\"right\"><INPUT TYPE=\"submit\" VALUE=\"Register\">&nbsp;<INPUT TYPE=\"button\" VALUE=\"Cancel\" onClick=\"location.href='".$site_options["pre"]."map.php'\"></TD></TR>".$site_options["return"];
			                }
			                print "</TABLE></FORM>".$site_options["return"];

			                // end map
			                //
			                print "  </DIV>".$site_options["return"];

			                break;

			case "node_find":
					print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
					print "  ".menu("You can move the pointer over nodes and click on links for further info.", "node_edit").$site_options["return"];
					print "  <FORM NAME=\"node_finder\" ACTION=\"javascript:findNode(document.forms['node_finder'].node_locate.value)\">".$site_options["return"];
			                print "  <BR>".$site_options["return"]."  Locate node by IP:<BR><INPUT TYPE=\"text\" NAME=\"node_locate\" SIZE=\"20\"><INPUT TYPE=\"BUTTON\" VALUE=\"Find ...\" onClick=\"findNode(document.forms['node_finder'].node_locate.value)\">".$site_options["return"];
			                print "  <BR><BR>".$site_options["return"]."  Locate node by Name:<BR><SELECT NAME=\"node_find_select\" SIZE=\"20\">".$site_options["return"];
			                $query  = "SELECT count(N.id) AS amount,N.id,N.address FROM ".$db_prefix."nodes AS N ";
			                if(!isset($_SESSION["user_role"]) OR ($_SESSION["user_role"] == "user"))
			                	$query .= "WHERE N.security != 'wan' ";
					$query .= " GROUP BY N.id ORDER BY N.address ";
			                $storequery .= $query."\n"; // debug
			                $q_nodes = $db->query($query);
			                if(DB::isError($q_nodes)) db_error_handling($q_nodes, $query);
			                // get nodelist from database
			                while($row    = $q_nodes->fetchRow(DB_FETCHMODE_ASSOC))
			                	print "    <OPTION onClick=\"findMarker(".$row["id"].")\">".$row["address"]."</OPTION>".$site_options["return"];
			                print "  </SELECT>".$site_options["return"];
					print "</FORM></DIV>";
					break;
					
			default:
					print wan_map();
			                print "<DIV ID=\"Layer\" STYLE=\"position:absolute; top: 10px; left: 720px; width: 280px; height: 600px; z-index:2;\">".$site_options["return"];
					print "    ".menu("You can move the pointer over nodes and click on links for further info.", "node_add,node_edit,node_find,loc_add,user_edit").$site_options["return"];
					print "</DIV>";
   
	}

	$db->disconnect();
	
	//debug
	print "\n<!--\n".$storequery."\n";
	print_r($_SESSION);
	print "-->";

	print $footer;


?>