<?php

  /*
   *  $Id: db-upgrade.php,v 1.11 2007-10-30 20:28:45 marlow Exp $
   *
   *  database migration script
   *
   */

  include("../include/config.inc");
  
  $query     = "SHOW TABLES LIKE 'settings'";
  $q_version = $db->query($query);
  if(DB::isError($q_version)) db_error_handling($q_link, $query);
  
  if($q_version->numRows() == 0)
  {
    // upgrade from 20071023
    
    // snmp_link is deprecated
    $query  = "DROP TABLE IF EXISTS ".$db_prefix."snmp_link;";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);
    
    // we will store a version now for future database upgrades
    $query  = "CREATE TABLE ".$db_prefix."settings ( version varchar(8) NOT NULL ) ENGINE=MyISAM DEFAULT CHARSET=latin1;";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);
    
    // username for telnet login to run traceroute etc.
    $query  = "ALTER TABLE ".$db_prefix."node_ips ADD node_user VARCHAR(127) NOT NULL AFTER node_type, ADD node_status enum('up','down','client','nocheck','unknown') NOT NULL default 'unknown' AFTER node_pw, ";
    $query .= "ADD date_status varchar(128) NOT NULL AFTER node_status, ADD date_seen varchar(128) NOT NULL AFTER date_status;";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    // interface status
    $query  = "ALTER TABLE ".$db_prefix."snmp_mac ADD int_status enum('up','down','manual') NOT NULL AFTER interface, ADD nid int(10) unsigned NOT NULL AFTER node_id, ADD nip int(10) unsigned NOT NULL AFTER nid, ";
    $query .= "ADD date_status varchar(128) NOT NULL AFTER node_essid;";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    // insert database version
    $query  = "INSERT INTO ".$db_prefix."settings (version) VALUES('20071026')";    
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);
    
    print "Upgrade to 20071026 completed ...<BR>";
  }

  $query     = "SELECT version FROM ".$db_prefix."settings";
  $q_version = $db->query($query);
  if(DB::isError($q_version)) db_error_handling($q_link, $query);
  $row = $q_version->fetchRow(DB_FETCHMODE_ASSOC);
  
  if($row["version"] == "20071026")
  {
    // username for telnet login to run traceroute etc.
    $query  = "ALTER ".$db_prefix."TABLE node_ips ADD node_uptime VARCHAR(128) NOT NULL AFTER node_status";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    // insert database version
    $query  = "UPDATE ".$db_prefix."settings SET version='20071028'";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    print "Upgrade to 20071028 completed ...<BR>";
    $row["version"] = "20071028";
  }

  if($row["version"] == "20071028")
  {
    // there are hosts, that don't support snmp
    $query  = "ALTER TABLE ".$db_prefix."node_ips CHANGE node_type node_type enum('','staros','mikrotik','icarus','nosnmp') NOT NULL";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    $query  = "TRUNCATE ".$db_prefix."snmp_node";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    $query  = "TRUNCATE ".$db_prefix."snmp_mac";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    // insert database version
    $query  = "UPDATE ".$db_prefix."settings SET version='20071029'";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    print "Upgrade to 20071029 completed ...<BR>";
    $row["version"] = "20071029";
  }
  
  if($row["version"] == "20071029")
  {
    // there are hosts, that don't support snmp
    $query  = "ALTER TABLE ".$db_prefix."nodes ADD `location` int(10) unsigned NOT NULL default '0' AFTER url;";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    // create locations table
    $query  = "CREATE TABLE ".$db_prefix."location (";
    $query .= "  `id` int(10) unsigned NOT NULL auto_increment,";
    $query .= "  `country` varchar(2) NOT NULL,";
    $query .= "  `region` varchar(2) NOT NULL,";
    $query .= "  `city` varchar(127) NOT NULL,";
    $query .= "  `lat` float(8,4) NOT NULL,";
    $query .= "  `lon` float(8,4) NOT NULL,";
    $query .= "  PRIMARY KEY  (`id`)";
    $query .= ") ENGINE=MyISAM DEFAULT CHARSET=latin1;";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    // insert database version
    $query  = "UPDATE ".$db_prefix."settings SET version='20071030'";
    $q_link = $db->query($query);
    if(DB::isError($q_link)) db_error_handling($q_link, $query);

    print "Upgrade to 20071030 completed ...<BR>";
    $row["version"] = "20071030";
  }
  
  
?>