<?php

	/*
	 *  $Id: xml.php,v 1.138 2007-10-30 13:45:21 marlow Exp $
	 *
	 *  XML output of map data
	 *
	 */

	include("include/config.inc");

	// convert IP-address to numeric
	//
	function ipnum($ip)
	{
		// ip-address = w.x.y.z

		// w
		$pos   = strpos($ip, ".");
		$ipnum = (16777216*(intval(substr($ip, 0, $pos))));
		// x
		$opos  = $pos;
		$pos   = strpos($ip, ".", $opos+1);
		$ipnum = ($ipnum + (65536*(intval(substr($ip, $opos+1, $pos-$opos-1)))));
		// y
		$opos  = $pos;
		$pos   = strpos($ip, ".", $opos+1);
		$ipnum = ($ipnum + (256*(intval(substr($ip, $opos+1, $pos-$opos-1)))));
		// z
		$opos  = $pos;
		$ipnum = ($ipnum + intval(substr($ip, $opos+1)));

		return $ipnum;
	}

	function uptime($uptime, $factor=100)
	{
		$uptime_string = "";
		
		// days
		if($uptime >= (86400*$factor))
		{
			$days   = intval($uptime/(86400*$factor));
			$uptime = ($uptime-($days*(86400*$factor)));
			$uptime_string .= $days." days, ";
		}
		
		// hours
		if($uptime >= (3600*$factor))
		{
			$hours  = intval($uptime/(3600*$factor));
			$uptime = ($uptime-($hours*(3600*$factor)));
			if(strlen($hours) == 1) $uptime_string .= "0";
			$uptime_string .= $hours.":";
		} else
			if($uptime_string != "") $uptime_string .= "00:";
		
		// minutes
		if($uptime >= (60*$factor))
		{
			$min    = intval($uptime/(60*$factor));
			$uptime = ($uptime-($min*(60*$factor)));
			if(strlen($min) == 1) $uptime_string .= "0";
			$uptime_string .= $min.":";
		} else
			if($uptime_string != "") $uptime_string .= "00:";
		
		// seconds
		if($factor >= 100)
			if($uptime >= 100)
			{
				$sec    = intval($uptime/100);
				$uptime = ($uptime-($sec*100));
				if(strlen($sec) == 1) $uptime_string .= "0";
				$uptime_string .= $sec.".";
			} else
				if($uptime_string != "") $uptime_string .= "00.";
		
		if(strlen($uptime) == 1) $uptime_string .= "0";
		$uptime_string .= $uptime;
		
		return $uptime_string;
	}

	header('Content-type: text/xml');
	header('Content-Disposition: attachment; filename="wifimap.xml"');

	switch($_GET["action"])
	{
		case "locate":
		
			$query  = "SELECT N.id, N.address, NI.ip, NI.node_type ";
			$query .= "FROM ".$db_prefix."snmp_mac AS SM ";
			$query .= "JOIN ".$db_prefix."snmp_mac AS SM2 ON SM.node_id = SM2.node_id ";
			$query .= "LEFT JOIN ".$db_prefix."node_ips AS NI ON NI.ip = SM2.ip ";
			$query .= "LEFT JOIN ".$db_prefix."nodes AS N ON NI.node_id = N.id ";
			$query .= "WHERE SM.network <= ".ipnum($_GET["ip"])." ";
			$query .= "AND SM.broadcast >= ".ipnum($_GET["ip"])." ";
			$query .= "AND NI.id IS NOT NULL ";
			$q_loc = $db->query($query);
			if(DB::isError($q_loc)) db_error_handling($q_loc, $query);

			$loc = $q_loc->fetchRow(DB_FETCHMODE_ASSOC);

			$output  = "<nodesearch>".$site_options["return"];
			if($loc["id"] == "")
				$output .= "  <node id=\"0\"/>".$site_options["return"];
			else
				$output .= "  <node id=\"".$loc["id"]."\"/>".$site_options["return"];
			$output .= "</nodesearch>".$site_options["return"];
			break;
			
		default:
			// query all nodes, that are on map
			//
			$query  = "SELECT N.*,NI.ip,NI.node_status,NI.node_uptime,NI.date_status,NI.date_seen FROM ".$db_prefix."nodes AS N LEFT JOIN ".$db_prefix."node_ips AS NI ON NI.node_id=N.id ";
			if(!isset($_SESSION["user_role"]) OR ($_SESSION["user_role"] == "user")) 
				$query .= "WHERE N.security != 'wan' ";
			$query .= " ORDER BY N.address,NI.ip ";
			$node           = array();
			$node["ip"]     = array();
			$node["status"] = array();
			$node["uptime"] = array();
			$node["date"]   = array();

			$q_shownode = $db->query($query);
			if(DB::isError($q_shownode)) db_error_handling($q_shownode, $query);

			$output = "<nodeinfo>".$site_options["return"];
			while($row = $q_shownode->fetchRow(DB_FETCHMODE_ASSOC))
			{
				if($node["id"] != $row["id"] AND $node["id"] != "")
				{
					// check status of all routers
					//
					$router = "";
					$status = "";
					for($x=0; $x<count($node["ip"]); $x++)
					{
						if($status == "") $status = $node["status"][$x];
						if($status != $node["status"][$x]) $status = "partial";
						$router .= "<FONT STYLE=\"font-size: 9px;";
						if($node["status"][$x] == "down") $router .= " color: #CC0011;\"";
						$router .= "\">";
						$router .= long2ip($node["ip"][$x])." - ".$node["status"][$x];
						if($node["status"][$x] == "up" AND $node["uptime"][$x] != "") $router .= "<BR>&nbsp;&nbsp;&nbsp;System uptime: ".uptime($node["uptime"][$x]);
						if($node["status"][$x] != "unknown" AND $node["date"][$x] != "") $router .= "<BR>&nbsp;&nbsp;&nbsp;Last status change: ".uptime(time()-intval($node["date"][$x]),1)." ago";
						$router .= "<BR></FONT>";
					}
					// no routers defined ??
					//
					if($status == "")
					{
						$status = "unknown";
						$router = "";
					}
				
					// all routers queried, print data available
					//
					$output .= "  <marker id=\"".$node["id"]."\" lat=\"".$node["lat"]."\" lon=\"".$node["lon"]."\" status=\"".$status."\" time=\"".date("d.m.Y H:i", intval($node["seen"]))."\">";
					$output .= "    <location><![CDATA[".$node["address"]."]]></location>".$site_options["return"];
					$output .= "    <comment><![CDATA[".$node["comment"]."]]></comment>".$site_options["return"];
					$output .= "    <url><![CDATA[".$node["url"]."]]></url>".$site_options["return"];
					$output .= "    <router><![CDATA[".$router."]]></router>".$site_options["return"];
					$output .= "  </marker>".$site_options["return"];
					
					// empty arrays
					//
					$node["ip"]     = array();
					$node["status"] = array();
					$node["uptime"] = array();
					$node["date"]   = array();
				}
				$node["id"]       = $row["id"];
				$node["lat"]      = $row["latitude"];
				$node["lon"]      = $row["longitude"];
				$node["address"]  = $row["address"];
				$node["comment"]  = $row["comment"];
				$node["url"]      = $row["url"];
				$node["ip"][]     = $row["ip"];
				$node["status"][] = $row["node_status"];
				$node["uptime"][] = $row["node_uptime"];
				$node["date"][]   = $row["date_status"];
				$node["seen"]     = $row["date_seen"];
			}

			// check status of last router
			//
			$router = "";
			$status = "";
			for($x=0; $x<count($node["ip"]); $x++)
			{
				if($status == "") $status = $node["status"][$x];
				if($status != $node["status"][$x]) $status = "partial";
				$router .= "<FONT STYLE=\"font-size: 9px;";
				if($node["status"][$x] == "down") $router .= " color: #CC0011;\"";
				$router .= "\">";
				$router .= long2ip($node["ip"][$x])." - ".$node["status"][$x];
				if($node["status"][$x] == "up") $router .= "<BR>&nbsp;&nbsp;&nbsp;System uptime: ".uptime($node["uptime"][$x]);
				if($node["status"][$x] != "unknown" AND $node["date"][$x] != "") $router .= "<BR>&nbsp;&nbsp;&nbsp;Last status change: ".uptime(time()-intval($node["date"][$x]),1)." ago";
				$router .= "<BR></FONT>";
			}
			// no routers defined ??
			//
			if($status == "")
			{
				$status = "unknown";
				$router = "";
			}
				
			// all routers queried, print data available
			//
			$output .= "  <marker id=\"".$node["id"]."\" lat=\"".$node["lat"]."\" lon=\"".$node["lon"]."\" status=\"".$status."\" time=\"".date("d.m.Y H:i", intval($node["seen"]))."\">";
			$output .= "    <location><![CDATA[".$node["address"]."]]></location>".$site_options["return"];
			$output .= "    <comment><![CDATA[".$node["comment"]."]]></comment>".$site_options["return"];
			$output .= "    <url><![CDATA[".$node["url"]."]]></url>".$site_options["return"];
			$output .= "    <router><![CDATA[".$router."]]></router>".$site_options["return"];
			$output .= "  </marker>".$site_options["return"];
			
			// empty arrays
			//
			$node["ip"]     = array();
			$node["status"] = array();

			$query  = "SELECT n1.longitude AS n1x, n1.latitude AS n1y, sm1.int_status AS n1s, n1.address AS n1a, n2.longitude AS n2x, n2.latitude AS n2y, sm2.int_status AS n2s, n2.address AS n2a, ";
			$query .= "ni1.node_status AS ni1s, ni2.node_status AS ni2s ";
			$query .= "FROM ".$db_prefix."snmp_mac AS sm1 ";
			$query .= "INNER JOIN ".$db_prefix."snmp_mac AS sm2 ON sm1.network = sm2.network ";
			$query .= "AND sm1.broadcast = sm2.broadcast ";
			$query .= "AND sm1.ip < sm2.ip ";
			$query .= "AND sm1.netmask !=0 ";
			$query .= "LEFT JOIN ".$db_prefix."nodes AS n1 ON sm1.nid = n1.id ";
			$query .= "LEFT JOIN ".$db_prefix."nodes AS n2 ON sm2.nid = n2.id ";
			$query .= "LEFT JOIN ".$db_prefix."node_ips AS ni1 ON sm1.nip = ni1.id ";
			$query .= "LEFT JOIN ".$db_prefix."node_ips AS ni2 ON sm2.nip = ni2.id ";
			$query .= "WHERE n1.id IS NOT NULL AND n2.id IS NOT NULL ";

			if(!isset($_SESSION["user_role"]) OR ($_SESSION["user_role"] == "user")) 
				$query .= "AND n1.security != 'wan' AND n2.security != 'wan' ";

			$status = "";
			$q_link = $db->query($query);
			if(DB::isError($q_link)) db_error_handling($q_link, $query);
			
			while($row = $q_link->fetchRow(DB_FETCHMODE_ASSOC))
			{
				// if one side of the link is down, the link is down (red)
				if($row["n1s"] == "down" OR $row["n2s"] == "down" OR $row["ni1s"] == "down" OR $row["ni2s"] == "down")
					$status = "#CC0011";
				// if one side of the link are manual, there's no way to determine the status, (blue)
				if($row["n1s"] == "manual" OR $row["n2s"] == "manual")
					$status = "#0000FF";
				// if status isn't set, the link is assumed to be up (green)
				if($status == "") $status = "#00EE55";
				$output .= "  <polyline latstart=\"".$row["n1y"]."\" lonstart=\"".$row["n1x"]."\" latend=\"".$row["n2y"]."\" lonend=\"".$row["n2x"]."\" status=\"".$status."\" status_start=\"".$row["n1s"]."\" status_end=\"".$row["n2s"]."\">".$site_options["return"];
				$output .= "    <node_start><![CDATA[".$row["n1a"]."]]></node_start>".$site_options["return"];
				$output .= "    <node_end><![CDATA[".$row["n2a"]."]]></node_end>".$site_options["return"];
				$output .= "  </polyline>".$site_options["return"];
				$status = "";
			}
			$output .= "</nodeinfo>".$site_options["return"];
	}

	print $output;
?>